// JavaScript Document
/**
 * ========================================〓说明〓========================================================
 * 仿淘宝焦点图效果。兼容IE6/IE7/IE8/IE9,FireFox,Chrome,Opera(IE下不兼容圆角)。
 * 需要修改样式的请修改css文件中的样式 但请勿更改样式名
 * 建议在img标签里面 设置图片的宽度和高度 和title alt属性
 * @name runImg.js
 * @version 1.0.1
 * @author Jmarry(wyf)
 * @date 2012-02-25
 * @Email:385152712@qq.com
 *
 * 欲提交bug或者想了解使用方法请登录 http://www.cnblogs.com/wyflogo 欢迎留言
 **/
function runImg(){}
runImg.prototype={
	bigbox:null,//最外层容器
	boxul:null,//子容器ul
	imglist:null,//子容器img
	numlist:null,//子容器countNum
	prov:0,//上次显示项
	index:0,//当前显示项
	timer:null,//控制图片转变效果
	play:null,//控制自动播放
	imgurl:[],//存放图片
	count:0,//存放的个数
	zIndex:0,//设置样式z-index的值，记得如果要修改请先查看countNum的值，要小于它！
	$:function(obj)
	{
		if(typeof(obj)=="string")
		{
			if(obj.indexOf("#")>=0)
			{
				obj=obj.replace("#","");
				if(document.getElementById(obj))
				{
					return document.getElementById(obj);
				}
				else
				{
					alert("没有容器"+obj);
					return null;
				}	
			}
			else
			{
				return document.createElement(obj);
			}
		}
		else
		{
			return obj;
		}
	},
	//初始化
	info:function(id)
	{
		this.count=this.count<=5?this.count:5;
		this.bigbox=this.$(id);
		for(var i=0;i<2;i++)
		{
			var ul=this.$("ul");
			for(var j=1;j<=this.count;j++)
			{
				var li=this.$("li");
				li.innerHTML=i==0?this.imgurl[j-1]:j;
				ul.appendChild(li);
			}
			this.bigbox.appendChild(ul);
		}
		this.boxul=this.bigbox.getElementsByTagName("ul");
		this.boxul[0].className="imgList";
		this.boxul[1].className="countNum";
		this.imglist=this.boxul[0].getElementsByTagName("li");
		this.numlist=this.boxul[1].getElementsByTagName("li");
		for(var j=0;j<this.imglist.length;j++)
		{
			this.alpha(j,0);
		}
		this.alpha(0,100);
		this.imglist[0].style.zIndex=this.zIndex;
		this.numlist[0].className="current";
	},
	//封装程序入口
	action:function(id)
	{
		this.autoplay();
		this.mouseoverout(this.bigbox,this.numlist);
	},
	//图片切换效果
	imgshow:function(num,numlist,imglist)
	{
		this.index=num;
		var pralpha=100;
		var inalpha=0;
		for(var i=0;i<numlist.length;i++)
		{
			numlist[i].className="";
		}
		numlist[this.index].className="current";
		clearInterval(this.timer);
		for(var j=0;j<this.imglist.length;j++)
		{
			this.alpha(j,0);
			imglist[j].style.zIndex="";
		}
		imglist[this.index].style.zIndex=this.zIndex;
		this.alpha(this.prov,100);
		this.alpha(this.index,0);
		var $this=this;
		//利用透明度来实现切换图片
		this.timer=setInterval(function(){
			inalpha+=2;
			pralpha-=2;
			if(inalpha>100){inalpha=100};//不能大于100
			if(pralpha<0){pralpha=100};
			//为兼容性赋样式
			$this.alpha($this.prov,pralpha);
			$this.alpha($this.index,inalpha);
			if(inalpha==100&&pralpha==0){
				clearInterval($this.timer);
				};//当等于100的时候就切换完成了
		},20)//经测试20是我认为最合适的值
	},
	//设置透明度
	alpha:function(i,opacity){
		this.imglist[i].style.opacity=opacity/100;
		this.imglist[i].style.filter="alpha(opacity="+opacity+")";
	},
	//自动播放
	autoplay:function(){
		var $this=this;
		this.play=setInterval(function(){
			$this.prov=$this.index;
			$this.index++;
			if($this.index>$this.imglist.length-1){$this.index=0};
			$this.imgshow($this.index,$this.numlist,$this.imglist);
			},2000)
	},
	//处理鼠标事件
	mouseoverout:function(box,numlist)
	{
		var $this=this;
		box.onmouseover=function()
		{
			clearInterval($this.play);
		}
		box.onmouseout=function()
		{
			$this.autoplay($this.index);
		}
		for(var i=0;i<numlist.length;i++)
		{
			numlist[i].index=i;
			numlist[i].onmouseover=function(){
				$this.prov=$this.index;
				$this.imgshow(this.index,$this.numlist,$this.imglist);
			}
		}
	}
}